function AssaultMission:StartActivity()
--[[
Assault
	a King of the Hill style gamemode.
	Capture over 3 of the 4 Zones to take control of the base.
	Capture Zones by having more bodies in the area than your opponent.
	Hold the base longer than your opponent within the time limit to win!
	
	The attacker recieves gold slightly faster than the defender.
	AI will move attacking troops directly to a random zone.
	Defending troops move to area directly underneath the drop zone.
	
	--Aspect
	thanks to mail2345 for randomized starting player
		and for fixing up spawns
	
	
	
	Game Options below
]]--

--[[
Reinforcement Number
	CoalitionStandard = 1
	RoninStandard = 2
	DummyStandard = 3
	CoalitionHeavy = 4
	RoninHeavy = 5
	SuperHeavy = 6
]]--
	ReinforcementsRandom = 1 -- if 1, makes each reinforcement random
							-- next step: team based re-inforcements.
							-- eg. coalition vs dummy.
							-- (feel free to step in, anyone else)
	ReinforcementType = 1 --Corresponds to number in table above
						--Incomplete, all but option 6 are finished.
						--If ReinforcementsRandom = 1, this is overridden.
--Time limit
	timelimit = false --Set to false if you wish to play with only the goal limit
	maxtime = 1200 --Amount of time until the match is over (in seconds)
--Goal limit
	goaltimelimit = true --Set to false if you wish to play with only the time limit
	maxgoaltime = 480 --Number of seconds needed to win
--Drop Times 
	RespawnTimeDefense = 15000 --(in milliseconds, multiply seconds by 1000)
	RespawnTimeOffense = 8000 -- this is on hard mode, fyi
--Starting Funds
	DefenseStartFunds = 0 --(in oz. Gold)
	OffenseStartFunds = 1000
--Money Rate
	MoneyOn = false --Set to true if you wish to play with pensions
	MoneyTimeDefense = 750 --(in milliseconds)
	MoneyTimeOffense = 500
	MoneyRateDefense = 1.5 --(in oz. Gold)
	MoneyRateOffense = 2
--AI Moves to Zones
	AI = true --Set to false if you wish to play manually
				-- but you shouldn't, the new AI is fun.
--Handicap? (in seconds)
	p1score = 0
	p2score = 0
	
	
	
	
--Don't bother messing with the below values	
	loltimer = 0; --A fix for the bizzare don't touch actors within the first 15 iterations glitch.
	p1Zone0control = 0
	p1Zone1control = 0
	p1Zone2control = 0
	p1Zone3control = 0
	p2Zone0control = 0
	p2Zone1control = 0
	p2Zone2control = 0
	p2Zone3control = 0
	Zone0control = 0
	Zone1control = 0
	Zone2control = 0
	Zone3control = 0
	ZonesFull = false
	basecontrol = -1
	p1spawnactive = false
	p2spawnactive = false
	secondtimer = Timer()
	TimeCheck = 1000
	timelimittimer = Timer()
	timeleft = 999
	defendspawntimer = Timer()
	attackspawntimer = Timer()
	defendmoneytimer = Timer()
	attackmoneytimer = Timer()
	Zone0 = SceneMan.Scene:GetArea("Zone0")
	Zone1 = SceneMan.Scene:GetArea("Zone1")
	Zone2 = SceneMan.Scene:GetArea("Zone2")
	Zone3 = SceneMan.Scene:GetArea("Zone3")
	Start0 = SceneMan.Scene:GetArea("Start0")
	Start1 = SceneMan.Scene:GetArea("Start1")
	Start2 = SceneMan.Scene:GetArea("Start2")
	Start3 = SceneMan.Scene:GetArea("Start3")
	attacklz0 = SceneMan.Scene:GetArea("attacklz0")
	attacklz1 = SceneMan.Scene:GetArea("attacklz1")
	attacklz2 = SceneMan.Scene:GetArea("attacklz2")
	defendlz = SceneMan.Scene:GetArea("defendlz")
	defensemove = SceneMan.Scene:GetArea("defensemove")
	
	ActivityMan:GetActivity():SetTeamFunds(DefenseStartFunds,0)
	ActivityMan:GetActivity():SetTeamFunds(OffenseStartFunds,1)	
	self.RedLight0 = CreateAEmitter("RScreenEmitter");
 	self.RedLight0:EnableEmission(true);
	self.RedLight0.Pos = Vector(756,1380);
	MovableMan:AddParticle(self.RedLight0);
	self.GreenLight0 = CreateAEmitter("GScreenEmitter");
	self.GreenLight0:EnableEmission(true);
	self.GreenLight0.Pos = Vector(756,1380);
	MovableMan:AddParticle(self.GreenLight0);
	
	self.RedLight1 = CreateAEmitter("RScreenEmitter");
	self.RedLight1:EnableEmission(true);
	self.RedLight1.Pos = Vector(852,1380);
	MovableMan:AddParticle(self.RedLight1);
	self.GreenLight1 = CreateAEmitter("GScreenEmitter");
	self.GreenLight1:EnableEmission(true);
	self.GreenLight1.Pos = Vector(852,1380);
	MovableMan:AddParticle(self.GreenLight1);
	
	self.RedLight2 = CreateAEmitter("RScreenEmitter");
	self.RedLight2:EnableEmission(true);
	self.RedLight2.Pos = Vector(1368,948);
	MovableMan:AddParticle(self.RedLight2);
	self.GreenLight2 = CreateAEmitter("GScreenEmitter");
	self.GreenLight2:EnableEmission(true);
	self.GreenLight2.Pos = Vector(1368,948);
	MovableMan:AddParticle(self.GreenLight2);
	
	
	self.RedLight3 = CreateAEmitter("RScreenEmitter");
	self.RedLight3:EnableEmission(true);
	self.RedLight3.Pos = Vector(1952.27,1116);
	MovableMan:AddParticle(self.RedLight3);
	self.GreenLight3 = CreateAEmitter("GScreenEmitter");
	self.GreenLight3:EnableEmission(true);
	self.GreenLight3.Pos = Vector(1952.27,1116);
	MovableMan:AddParticle(self.GreenLight3);
	
	-- AI Timer and Tables For Movements (Geti)
	movetimer = Timer();
	-- TEMPLATE NAME: MoveHub<SIDE><LOCATION><PRONUMERAL> eg "MoveHubDefense0A"
	-- the variable names are the acronyms of the MoveHub name, eg "mhd0a", and are used to
	-- annotate map.png, found in the root of the .rte
	-- d tables for iterating for pathfinding
	mho0a = { "MoveHubDefenseLZ0A","MoveHubOffense2A","MoveHubOffense0B" };
	dmho0a = { mhdlz0a,mho2a,mho0b };
	mho0b = { "MoveHubDefense1B", "MoveHubOffense0A"};
	dmho0b = { mhd1b, mho0a};
	mhdlz0a = { "MoveHubOffense0A", "MoveHubDefense0A"};
	dmhdlz0a = { mho0a, mhd0a};
	mhd0a = { "MoveHubDefenseLZ0A", "MoveHubDefense0B", "MoveHubDefense0C"};
	dmhd0a = { mhdlz0a, mhd0b, mhd0c};
	mhd0b = { "MoveHubDefense0A", "MoveHubDefense0C", "MoveHubDefenseZ1A"};
	dmhd0b = { mhd0a, mhd0c, mhdz1a};
	mhd0c = { "MoveHubDefense0A", "MoveHubDefense0B",
					 "MoveHubDefenseZ0A", "MoveHubDefense2B"};
	dmhd0c = { mhd0a,mhd0b,mhdz0a,mhd2b }
	mhdz0a = { "MoveHubDefense0C", "MoveHubDefenseZ1A", "MoveHubDefense2C", "Zone0"};
	dmhdz0a = { mhd0c, mhdz1a, mhd2c, defz0};
	defz0 = { "MoveHubDefenseZ0A", "MoveHubDefenseZ1A", "Zone1"};
	ddefz0 = { mhdz0a, mhdz1a, defz1};
	mhdz1a = { "MoveHubDefense0B", "MoveHubDefenseZ0A", "MoveHubDefense1A"};
	dmhdz1a = { mhd0b, mhdz0a, mhd1a};
	defz1 = { "MoveHubDefenseZ0A", "MoveHubDefenseZ1A", "Zone0"};
	ddefz1 = { mhdz0a, mhdz1a, defz0};
	mhd1a = { "MoveHubDefenseZ1A", "MoveHubDefenseZ2A", "MoveHubDefense2B", "Zone2", "Zone3" };
	dmhd1a = { mhdz1a, mhdz2a, mhd2b, defz2, defz3 };
	mhd1b = { "MoveHubOffense0B", "MoveHubOffense1A"};
	dmhd1b = { mho0b, mh01a};
	mhdz2a = { "MoveHubDefense1A", "MoveHubOffense1A", "Zone2"};
	dmhdz2a = { mhd1a, mho1a, defz2};
	mho1a = { "MoveHubDefense1B", "MoveHubOffense2A", "MoveHubDefenseZ2A"};
	dmho1a = { mhd1b, mho2a, mhdz2a};
	mhd2a = { "MoveHubDefense2B", "MoveHubOffense2A", "Zone3"};
	dmhd2a = { mhd2b, mho2a, defz3};
	mhd2b = { "MoveHubDefense2C", "MoveHubDefense2A", "Zone3"};
	dmhd2b = { mhd2c, mhd2a, defz3};
	mhd2c = { "MoveHubDefenseZ0A", "MoveHubDefense2B"};
	dmhd2c = { mhdz0a, mhd2b};
	mho2a = { "MoveHubDefense2A", "MoveHubOffense1A", "MoveHubOffense0A"};
	dmho2a = { mhd2a, mho1a, mho0a};
	
	
--Randomize Starting Position
	which = math.random(1,2);
    if which == 2 then
		spawnteam = 1;
		ActivityMan:GetActivity():SetTeamFunds(DefenseStartFunds,1)
		ActivityMan:GetActivity():SetTeamFunds(OffenseStartFunds,0)
	end
	
	if which == 1 then
		spawnteam = 0;
		ActivityMan:GetActivity():SetTeamFunds(DefenseStartFunds,0)
		ActivityMan:GetActivity():SetTeamFunds(OffenseStartFunds,1)
	end
--Create Starting Soldiers	
	actor = MakeActor(Actor.AIMODE_SENTRY);
	actor:ClearAIWaypoints();
	actor.Team = spawnteam;
	actor.Pos = Vector(Start0:GetRandomPoint().X, Start0:GetRandomPoint().Y);
	MovableMan:AddActor(actor);
	
	actor = MakeActor(Actor.AIMODE_SENTRY);
	actor:ClearAIWaypoints();
	actor.Team = spawnteam;
	actor.Pos = Vector(Start1:GetRandomPoint().X, Start1:GetRandomPoint().Y);
	MovableMan:AddActor(actor);
	
	actor = MakeActor(Actor.AIMODE_SENTRY);
	actor:ClearAIWaypoints();
	actor.Team = spawnteam;
	actor.Pos = Vector(Start2:GetRandomPoint().X, Start2:GetRandomPoint().Y);
	MovableMan:AddActor(actor);
	
	actor = MakeActor(Actor.AIMODE_SENTRY);
	actor:ClearAIWaypoints();
	actor.Team = spawnteam;
	actor.Pos = Vector(Start3:GetRandomPoint().X, Start3:GetRandomPoint().Y);
	MovableMan:AddActor(actor);

	--Need brainz
	for player = 0, self.PlayerCount - 1 do
        -- Check if we already have a brain assigned
        if not self:GetPlayerBrain(player) then
            local foundBrain = MovableMan:GetUnassignedBrain(self:GetTeamOfPlayer(player));
            -- If we can't find an unassigned brain in the scene to give each player, then force to go into editing mode to place one
            if not foundBrain then
                self.ActivityState = Activity.EDITING;
                print("Can't find player brain for king assault game mode, forcing player to place one manually in edit mode!");
            else
                -- Set the found brain to be the selected actor at start
                self:SetPlayerBrain(foundBrain, player);
                self:SwitchToActor(foundBrain, player, self:GetTeamOfPlayer(player));
                self:SetLandingZone(self:GetPlayerBrain(player).Pos, player);
                -- Set the observation target to the brain, so that if/when it dies, the view flies to it in observation mode
                self:SetObservationTarget(self:GetPlayerBrain(player).Pos, player)
            end
        end
    end
	

end

--Spawning Actors
function MakeActor(whichMode)
	if(ReinforcementType == 1) then
		--local actor;
		--local which = math.random();
		if which > 0.25 then
			actor = CreateAHuman("Soldier Light","Coalition.rte");
		else
			actor = CreateAHuman("Soldier Heavy","Coalition.rte");
		end

		--local gun;
		
		which = math.random();
		if which > 0.92 then
			actor:AddInventoryItem(CreateHDFirearm("Shotgun","Coalition.rte"));
		elseif which > 0.89 then
			actor:AddInventoryItem(CreateHDFirearm("Auto Shotgun","Coalition.rte"));
		elseif which > 0.86 then
			actor:AddInventoryItem(CreateHDFirearm("Mauler Shotgun","Coalition.rte"));
		elseif which > 0.83 then
			actor:AddInventoryItem(CreateHDFirearm("Auto Cannon","Coalition.rte"));
		elseif which > 0.52 then
			actor:AddInventoryItem(CreateHDFirearm("Assault Rifle","Coalition.rte"));
		elseif which > 0.50 then
			actor:AddInventoryItem(CreateHDFirearm("Gatling Gun","Coalition.rte"));
		elseif which > 0.48 then
			actor:AddInventoryItem(CreateHDFirearm("Compact Assault Rifle","Coalition.rte"));
		elseif which > 0.45 then
			actor:AddInventoryItem(CreateHDFirearm("Rocket Launcher","Coalition.rte"));
		elseif which > 0.25 then
			actor:AddInventoryItem(CreateHDFirearm("Sniper Rifle","Coalition.rte"));
		elseif which > 0.22 then
			actor:AddInventoryItem(CreateHDFirearm("Heavy Sniper Rifle","Coalition.rte"));
		elseif which > 0.20 then
			actor:AddInventoryItem(CreateHDFirearm("Revolver Cannon","Coalition.rte"));
		elseif which > 0.05 then
			actor:AddInventoryItem(CreateHDFirearm("Spike Launcher","Coalition.rte"));
		else
			actor:AddInventoryItem(CreateHDFirearm("Flak Cannon","Coalition.rte"));
		end
		
		--local tool;
		which = math.random();
		if which > 0.85 then
			actor:AddInventoryItem(CreateHDFirearm("Pulse Digger","Coalition.rte"));
		elseif which > 0.75 then
			actor:AddInventoryItem(CreateHDFirearm("Grenade Launcher","Coalition.rte"));
		elseif which > 0.35 then
			actor:AddInventoryItem(CreateTDExplosive("Grenade","Coalition.rte"));
		elseif which > 0.30 then
			actor:AddInventoryItem(CreateHDFirearm("Concrete Sprayer","Coalition.rte"));
		elseif which > 0.29 then
			actor:AddInventoryItem(CreateTDExplosive("Stone","Ronin.rte"));
		end
		
		--local sidearm;
		which = math.random();
		if which > 0.70 then
			actor:AddInventoryItem(CreateHDFirearm("Pistol","Coalition.rte"));
		elseif which > 0.50 then
			actor:AddInventoryItem(CreateHDFirearm("Auto Pistol","Coalition.rte"));
		elseif which > 0.40 then
			actor:AddInventoryItem(CreateHDFirearm("Auto Shot Pistol","Coalition.rte"));
		end

		actor:SetControllerMode(Controller.CIM_AI, -1);
		actor.AIMode = whichMode;
		return actor;
	end
	if(ReinforcementType == 2) then
	
		--local actor;
		--local which = math.random();
		if which > 0.8 then
			actor = CreateAHuman("Dafred","Ronin.rte");
		elseif which > 0.64 then
			actor = CreateAHuman("Mia","Ronin.rte");
		elseif which > 0.48 then
			actor = CreateAHuman("Dimitri","Ronin.rte");
		elseif which > 0.32 then
			actor = CreateAHuman("Brutus","Ronin.rte");
		elseif which > 0.16 then
			actor = CreateAHuman("Sandra","Ronin.rte");
		else
			actor = CreateAHuman("Gordon","Ronin.rte");
		end

		--local gun;
		
		which = math.random();
		if which > 0.80 then
			actor:AddInventoryItem(CreateHDFirearm("Spaz12","Ronin.rte"));
		elseif which > 0.60 then
			actor:AddInventoryItem(CreateHDFirearm("M16","Ronin.rte"));
		elseif which > 0.40 then
			actor:AddInventoryItem(CreateHDFirearm("YAK47","Ronin.rte"));
		elseif which > 0.25 then
			actor:AddInventoryItem(CreateHDFirearm("Rifle Long","Ronin.rte"));
		elseif which > 0.15 then
			actor:AddInventoryItem(CreateHDFirearm("M1600","Ronin.rte"));
		elseif which > 0.5 then
			actor:AddInventoryItem(CreateHDFirearm("Sniper Rifle","Ronin.rte"));
		else
			actor:AddInventoryItem(CreateHDFirearm("Spaz1200","Ronin.rte"));
		end
		
		--local tool;
		which = math.random();
		if which > 0.85 then
			actor:AddInventoryItem(CreateHDFirearm("Shovel","Ronin.rte"));
		elseif which > 0.75 then
			actor:AddInventoryItem(CreateTDExplosive("Stick Grenade","Ronin.rte"));
		elseif which > 0.35 then
			actor:AddInventoryItem(CreateTDExplosive("Pineapple Grenade","Ronin.rte"));
		elseif which > 0.30 then
			actor:AddInventoryItem(CreateHDFirearm("Concrete Gun","Base.rte"));
		elseif which > 0.25 then
			actor:AddInventoryItem(CreateTDExplosive("Stone","Ronin.rte"));
		end
		
		--local sidearm;
		which = math.random();
		if which > 0.90 then
			actor:AddInventoryItem(CreateHDFirearm("Lady Pistol","Ronin.rte"));
		elseif which > 0.75 then
			actor:AddInventoryItem(CreateHDFirearm("Glock","Ronin.rte"));
		elseif which > 0.60 then
			actor:AddInventoryItem(CreateHDFirearm("HAK 20","Ronin.rte"));
		elseif which > 0.50 then
			actor:AddInventoryItem(CreateHDFirearm("Luger","Ronin.rte"));
		elseif which > 0.40 then
			actor:AddInventoryItem(CreateHDFirearm("Desert Eagle","Ronin.rte"));
		elseif which > 0.30 then
			actor:AddInventoryItem(CreateHDFirearm("Peacemaker","Ronin.rte"));
		elseif which > 0.20 then
			actor:AddInventoryItem(CreateHDFirearm("Shortgun","Ronin.rte"));
		elseif which > 0.15 then
			actor:AddInventoryItem(CreateHDFirearm("Pumpgun","Ronin.rte"));
		else
			actor:AddInventoryItem(CreateHDFirearm("Uzi","Ronin.rte"));
		
		end

		actor:SetControllerMode(Controller.CIM_AI, -1);
		actor.AIMode = whichMode;
		return actor;
	end
	if(ReinforcementType == 3) then
		--local actor;
		--local which = math.random();
		actor = CreateAHuman("Dummy","Dummy.rte");
		
		--local gun;
		
		which = math.random();
		if which > 0.65 then
			actor:AddInventoryItem(CreateHDFirearm("Nailgun","Dummy.rte"));
		elseif which > 0.25 then
			actor:AddInventoryItem(CreateHDFirearm("Blaster","Dummy.rte"));
		else
			actor:AddInventoryItem(CreateHDFirearm("Sniper Rifle","Dummy.rte"));
		end
		
		--local tool;
		which = math.random();
		if which > 0.85 then
			actor:AddInventoryItem(CreateHDFirearm("Turbo Digger","Dummy.rte"));
		elseif which > 0.70 then
			actor:AddInventoryItem(CreateHDFirearm("Grenade Launcher","Dummy.rte"));
		elseif which > 0.55 then
			actor:AddInventoryItem(CreateHDFirearm("Concrete Gun","Base.rte"));
		elseif which > 0.54 then
			actor:AddInventoryItem(CreateTDExplosive("Stone","Ronin.rte"));
		end
		
		--local sidearm;
		which = math.random();
		if which > 0.50 then
			actor:AddInventoryItem(CreateHDFirearm("Pistol","Dummy.rte"));
		elseif which > 0.40 then
			actor:AddInventoryItem(CreateHDFirearm("Nailgun","Dummy.rte"));	
		end
	end
	if(ReinforcementType == 4) then
		--local actor;
		--local which = math.random();
		if which > 0.85 then
			actor = CreateAHuman("Soldier Light","Coalition.rte");
		else
			actor = CreateAHuman("Soldier Heavy","Coalition.rte");
		end

		--local gun;
		
		which = math.random();
		if which > 0.85 then
			actor:AddInventoryItem(CreateHDFirearm("Auto Cannon","Coalition.rte"));
		elseif which > 0.75 then
			actor:AddInventoryItem(CreateHDFirearm("Gatling Gun","Coalition.rte"));
		elseif which > 0.60 then
			actor:AddInventoryItem(CreateHDFirearm("Rocket Launcher","Coalition.rte"));
		elseif which > 0.45 then
			actor:AddInventoryItem(CreateHDFirearm("Heavy Sniper Rifle","Coalition.rte"));
		elseif which > 0.30 then
			actor:AddInventoryItem(CreateHDFirearm("Revolver Cannon","Coalition.rte"));
		elseif which > 0.20 then
			actor:AddInventoryItem(CreateHDFirearm("Spike Cannon","Coalition.rte"));
		else
			actor:AddInventoryItem(CreateHDFirearm("Flak Cannon","Coalition.rte"));
		end
		
		--local tool;
		which = math.random();
		if which > 0.85 then
			actor:AddInventoryItem(CreateHDFirearm("Pulse Digger","Coalition.rte"));
		elseif which > 0.75 then
			actor:AddInventoryItem(CreateHDFirearm("Grenade Launcher","Coalition.rte"));
		elseif which > 0.35 then
			actor:AddInventoryItem(CreateTDExplosive("Grenade","Coalition.rte"));
		elseif which > 0.30 then
			actor:AddInventoryItem(CreateHDFirearm("Concrete Sprayer","Coalition.rte"));
		elseif which > 0.29 then
			actor:AddInventoryItem(CreateTDExplosive("Stone","Ronin.rte"));
		end
		
		--local sidearm;
		which = math.random();
		if which > 0.90 then
			actor:AddInventoryItem(CreateHDFirearm("Shotgun","Coalition.rte"));
		elseif which > 0.80 then
			actor:AddInventoryItem(CreateHDFirearm("Auto Pistol","Coalition.rte"));
		elseif which > 0.60 then
			actor:AddInventoryItem(CreateHDFirearm("Auto Shot Pistol","Coalition.rte"));
		end

		actor:SetControllerMode(Controller.CIM_AI, -1);
		actor.AIMode = whichMode;
		return actor;
	end
	if(ReinforcementType == 5) then
	
		--local actor;
		--local which = math.random();
		if which > 0.8 then
			actor = CreateAHuman("Dafred","Ronin.rte");
		elseif which > 0.64 then
			actor = CreateAHuman("Mia","Ronin.rte");
		elseif which > 0.48 then
			actor = CreateAHuman("Dimitri","Ronin.rte");
		elseif which > 0.32 then
			actor = CreateAHuman("Brutus","Ronin.rte");
		elseif which > 0.16 then
			actor = CreateAHuman("Sandra","Ronin.rte");
		else
			actor = CreateAHuman("Gordon","Ronin.rte");
		end

		--local gun;
		
		which = math.random();
		if which > 0.80 then
			actor:AddInventoryItem(CreateHDFirearm("Spaz1200","Ronin.rte"));
		elseif which > 0.70 then
			actor:AddInventoryItem(CreateHDFirearm("M16","Ronin.rte"));
		elseif which > 0.50 then
			actor:AddInventoryItem(CreateHDFirearm("YAK4700","Ronin.rte"));
		elseif which > 0.40 then
			actor:AddInventoryItem(CreateHDFirearm("Rifle Long","Ronin.rte"));
		elseif which > 0.30 then
			actor:AddInventoryItem(CreateHDFirearm("M1600","Ronin.rte"));
		elseif which > 0.10 then
			actor:AddInventoryItem(CreateHDFirearm("Bazooka","Ronin.rte"));
		elseif which > 0.5 then
			actor:AddInventoryItem(CreateHDFirearm("YAK47","Ronin.rte"));
		else
			actor:AddInventoryItem(CreateHDFirearm("Spaz12","Ronin.rte"));
		end
		
		--local tool;
		which = math.random();
		if which > 0.85 then
			actor:AddInventoryItem(CreateHDFirearm("Shovel","Ronin.rte"));
		elseif which > 0.75 then
			actor:AddInventoryItem(CreateTDExplosive("Stick Grenade","Ronin.rte"));
		elseif which > 0.35 then
			actor:AddInventoryItem(CreateTDExplosive("Pineapple Grenade","Ronin.rte"));
		elseif which > 0.30 then
			actor:AddInventoryItem(CreateHDFirearm("Concrete Gun","Base.rte"));
		elseif which > 0.25 then
			actor:AddInventoryItem(CreateTDExplosive("Stone","Ronin.rte"));
		end
		
		--local sidearm;
		which = math.random();
		if which > 0.95 then
			actor:AddInventoryItem(CreateHDFirearm("Lady Pistol","Ronin.rte"));
		elseif which > 0.85 then
			actor:AddInventoryItem(CreateHDFirearm("Glock","Ronin.rte"));
		elseif which > 0.75 then
			actor:AddInventoryItem(CreateHDFirearm("HAK 20","Ronin.rte"));
		elseif which > 0.65 then
			actor:AddInventoryItem(CreateHDFirearm("Luger","Ronin.rte"));
		elseif which > 0.55 then
			actor:AddInventoryItem(CreateHDFirearm("Desert Eagle","Ronin.rte"));
		elseif which > 0.40 then
			actor:AddInventoryItem(CreateHDFirearm("Peacemaker","Ronin.rte"));
		elseif which > 0.30 then
			actor:AddInventoryItem(CreateHDFirearm("Shortgun","Ronin.rte"));
		elseif which > 0.20 then
			actor:AddInventoryItem(CreateHDFirearm("Pumpgun","Ronin.rte"));
		else
			actor:AddInventoryItem(CreateHDFirearm("Uzi","Ronin.rte"));
		
		end

		actor:SetControllerMode(Controller.CIM_AI, -1);
		actor.AIMode = whichMode;
		return actor;
	end
end

function MakeCraft(range1,range2)
	local which = math.random(range1,range2);
	math.floor(which);
	if which == 5 then
		craft = CreateACRocket("Rocket MK1","Base.rte");
	elseif which == 4 then
		craft = CreateACRocket("Rocket MK2","Base.rte");
	elseif which == 3 then
		craft = CreateACDropShip("Drop Ship MK1","Base.rte");
	elseif which == 2 then
		craft = CreateACRocket("Rocklet","Dummy.rte");
	elseif which == 1 then
		craft = CreateACRocket("Drop Crate","Dummy.rte");
	elseif which == 0 then
		craft = CreateACDropShip("Drop Ship","Dummy.rte");
	end
	return craft;
end

function DecideGotoZone(_szone,_set,_dstart)
	path = {}
	pzone = _szone
	--decides zone to go to
	while pzone == _szone do
	pzone = math.floor(math.random(0,3))
	end
	if pzone == 0 then
		zone = "Zone0"
	elseif pzone == 1 then
		zone = "Zone1"
	elseif pzone == 2 then
		zone = "Zone2"
	else
		zone = "Zone3"
	end
	print(zone)
	done = 0
	key = math.floor(math.random(1,#_set));
	while done == 0 do
	node = _set[key];
	print(node);
	table.insert(path,node);
	if node == zone then
		done = 1
	end
	_reset = _dstart[key];
	_dstart = _dstart[key];
	key = math.floor(math.random(1,#_reset));
	end
	return path;
end

function AssaultMission:UpdateActivity()
	--Check scoring areas and update player count
	--If Reinforcements are random, change ReinforcementType
	if ReinforcementsRandom == 1 then
		ReinforcementType = math.floor(math.random(1,5))
	end
	--Single loop through actors means each actor is only accessed once. There shouldn't be any other "for actor in MovableMan" etc.
	team1count = 0
	team2count = 0
	-- AI Movement :
	-- if there are groups of actors at a cirtain point, some of them will leave the area. this is checked every 1.5 seconds.
	-- for more advanced movement, relay hubs could be scripted in, but this works fine for now.
	-- enjoy CPU vs CPU king of the hill, or at least more challenging bots ^^ ~Geti
	for actor in MovableMan.Actors do
		if(actor.Team == Activity.TEAM_1) then
			if(SceneMan.Scene:WithinArea("Zone0",actor.Pos)) then
				p1Zone0control = p1Zone0control + 1
				if movetimer:IsPastSimMS(1500) then
				if p1Zone0control >= 2 then
					actor:ClearAIWaypoints();
					path = DecideGotoZone(0,defz0,ddefz0)
					for count = 0, #path, 1 do
						local waypoint = path[count];
						local f = SceneMan.Scene:GetArea(waypoint);
						actor:AddAISceneWaypoint(Vector(f:GetRandomPoint().X,f:GetRandomPoint().Y));
					end
					actor.AIMode = Actor.AIMODE_GOTO;
					print("success")
				end
				end
			elseif(SceneMan.Scene:WithinArea("Zone1",actor.Pos)) then
				p1Zone1control = p1Zone1control + 1
				if movetimer:IsPastSimMS(1500) then
				if p1Zone1control >= 2 then
					actor:ClearAIWaypoints();
					path = DecideGotoZone(1,defz1,ddefz1)
					for count = 0, #path, 1 do
						local waypoint = path[count];
						local f = SceneMan.Scene:GetArea(waypoint);
						actor:AddAISceneWaypoint(Vector(f:GetRandomPoint().X,f:GetRandomPoint().Y));
					end
					actor.AIMode = Actor.AIMODE_GOTO;
				end
				end
			elseif(SceneMan.Scene:WithinArea("Zone2",actor.Pos)) then
				p1Zone2control = p1Zone2control + 1
				if movetimer:IsPastSimMS(1500) then
				if p1Zone2control >= 3 then
					local x = SceneMan.Scene:GetArea(DecideGotoZone(mhdefz2a))
					actor:ClearAIWaypoints();
					actor:AddAISceneWaypoint(Vector(x:GetRandomPoint().X,x:GetRandomPoint().Y));
					actor.AIMode = Actor.AIMODE_GOTO;
					actor.travelling = 1
				end
				end
			elseif(SceneMan.Scene:WithinArea("Zone3",actor.Pos)) then
				p1Zone3control = p1Zone3control + 1
				if movetimer:IsPastSimMS(1500) then
				if p1Zone3control >= 3 then
					local x = SceneMan.Scene:GetArea(DecideGotoZone(mhdef2b))
					actor:ClearAIWaypoints();
					actor:AddAISceneWaypoint(Vector(x:GetRandomPoint().X,x:GetRandomPoint().Y));
					actor.AIMode = Actor.AIMODE_GOTO;
					actor.travelling = 1
				end
				end
			end
			if(SceneMan.Scene:WithinArea("defensemove",actor.Pos)) and basecontrol == 0 then
				if movetimer:IsPastSimMS(1500) then
				actor:ClearAIWaypoints();
				actor:AddAISceneWaypoint(DecideGotoZone():GetRandomPoint());
				actor.AIMode = Actor.AIMODE_GOTO;
				end
			end
		elseif(actor.Team == Activity.TEAM_2) then
			if(SceneMan.Scene:WithinArea("Zone0",actor.Pos)) then
				p2Zone0control = p2Zone0control + 1
				if movetimer:IsPastSimMS(1500) then
				if p2Zone0control >= 2 then
					actor:ClearAIWaypoints();
					actor:AddAISceneWaypoint(DecideGotoZone():GetRandomPoint());
					actor.AIMode = Actor.AIMODE_GOTO;
				end
				end
			elseif(SceneMan.Scene:WithinArea("Zone1",actor.Pos)) then
				p2Zone1control = p2Zone1control + 1
				if movetimer:IsPastSimMS(1500) then
				if p2Zone1control >= 2 then
					actor:ClearAIWaypoints();
					actor:AddAISceneWaypoint(DecideGotoZone():GetRandomPoint());
					actor.AIMode = Actor.AIMODE_GOTO;
				end
				end
			elseif(SceneMan.Scene:WithinArea("Zone2",actor.Pos)) then
				p2Zone2control = p2Zone2control + 1
				if movetimer:IsPastSimMS(1500) then
				if p2Zone2control >= 3 then
					actor:ClearAIWaypoints();
					actor:AddAISceneWaypoint(DecideGotoZone():GetRandomPoint());
					actor.AIMode = Actor.AIMODE_GOTO;
				end
				end
			elseif(SceneMan.Scene:WithinArea("Zone3",actor.Pos)) then
				p2Zone3control = p2Zone3control + 1
				if movetimer:IsPastSimMS(1500) then
				if p2Zone3control >= 3 then
					actor:ClearAIWaypoints();
					actor:AddAISceneWaypoint(DecideGotoZone():GetRandomPoint());
					actor.AIMode = Actor.AIMODE_GOTO;
				end
				end
			end
			if(SceneMan.Scene:WithinArea("defensemove",actor.Pos)) and basecontrol == 1 then
				if movetimer:IsPastSimMS(1500) then
				actor:ClearAIWaypoints();
				actor:AddAISceneWaypoint(DecideGotoZone():GetRandomPoint());
				actor.AIMode = Actor.AIMODE_GOTO;
				end
			end
		end
	end

	-- wipe the movetimer
	if movetimer:IsPastSimMS(1500) then
	movetimer:Reset()
	end
	
--Set Zone0 Control
	if(p1Zone0control > p2Zone0control) then
			Zone0control = -1
			p1Zone0control = 0
			p2Zone0control = 0
			self.GreenLight0:EnableEmission(false);
			self.RedLight0:EnableEmission(true);
	elseif(p2Zone0control > p1Zone0control) then
			Zone0control = 1
			p1Zone0control = 0
			p2Zone0control = 0
			self.GreenLight0:EnableEmission(true);
			self.RedLight0:EnableEmission(false);
	else
			Zone0control = 0
			p1Zone0control = 0
			p2Zone0control = 0
			self.GreenLight0:EnableEmission(false);
			self.RedLight0:EnableEmission(false);
	end

--Set Zone1 Control
	if(p1Zone1control > p2Zone1control) then
			Zone1control = -1
			p1Zone1control = 0
			p2Zone1control = 0
			self.GreenLight1:EnableEmission(false);
			self.RedLight1:EnableEmission(true);
	elseif(p2Zone1control > p1Zone1control) then
			Zone1control = 1
			p1Zone1control = 0
			p2Zone1control = 0
			self.GreenLight1:EnableEmission(true);
			self.RedLight1:EnableEmission(false);
	else
			Zone1control = 0
			p1Zone10control = 0
			p2Zone1control = 0
			self.GreenLight1:EnableEmission(false);
			self.RedLight1:EnableEmission(false);
	end
	
--Set Zone2 Control
	if(p1Zone2control > p2Zone2control) then
			Zone2control = -1
			p1Zone2control = 0
			p2Zone2control = 0
			self.GreenLight2:EnableEmission(false);
			self.RedLight2:EnableEmission(true);
	elseif(p2Zone2control > p1Zone2control) then
			Zone2control = 1
			p1Zone2control = 0
			p2Zone2control = 0
			self.GreenLight2:EnableEmission(true);
			self.RedLight2:EnableEmission(false);
	else
			Zone2control = 0
			p1Zone2control = 0
			p2Zone2control = 0
			self.GreenLight2:EnableEmission(false);
			self.RedLight2:EnableEmission(false);
	end
	
--Set Zone3 Control
	if(p1Zone3control > p2Zone3control) then
			Zone3control = -1
			p1Zone3control = 0
			p2Zone3control = 0
			self.GreenLight3:EnableEmission(false);
			self.RedLight3:EnableEmission(true);
	elseif(p2Zone3control > p1Zone3control) then
			Zone3control = 1
			p1Zone3control = 0
			p2Zone3control = 0
			self.GreenLight3:EnableEmission(true);
			self.RedLight3:EnableEmission(false);
	else
			Zone3control = 0
			p1Zone3control = 0
			p2Zone3control = 0
			self.GreenLight3:EnableEmission(false);
			self.RedLight3:EnableEmission(false);
	end

--Total Values for Zone Control	
	ZoneControlTotal = Zone0control + Zone1control + Zone2control + Zone3control

--Find Base Control	
	if(Zone0control == 0) then
		ZonesFull = false
	elseif(Zone1control == 0) then
		ZonesFull = false
	elseif(Zone2control == 0) then
		ZonesFull = false
	elseif(Zone3control == 0) then
		ZonesFull = false
	else
		ZonesFull = true
	end
	
--Set Base Control
	if(ZoneControlTotal < -1 and ZonesFull == true) then
		basecontrol = 0
	elseif(ZoneControlTotal > 1 and ZonesFull == true) then
		basecontrol = 1
	elseif(ZoneControlTotal < -2 and ZonesFull == false) then
		basecontrol = 0
	elseif(ZoneControlTotal > 2 and ZonesFull == false) then
		basecontrol = 1
	else
		basecontrol = -1
	end
	
--Door Team Switch
	if(basecontrol == 0) then
		for door in MovableMan.Actors do  
			if door.ClassName == "ADoor" then
				door.Team = 0
			end
		end
	elseif(basecontrol == 1) then
		for door in MovableMan.Actors do  
			if door.ClassName == "ADoor" then
				door.Team = 1
			end
		end
	else
		for door in MovableMan.Actors do  
			if door.ClassName == "ADoor" then
				door.Team = -1
			end
		end
	end	
--Score Timer
	if(basecontrol == 0) then
		if(secondtimer:IsPastSimMS(TimeCheck)) then
			p1score = p1score + 1	
			secondtimer:Reset()
		end
	elseif(basecontrol == 1)then
		if(secondtimer:IsPastSimMS(TimeCheck)) then
			p2score = p2score + 1	
			secondtimer:Reset()
		end
	end
--Money	Off
	if(MoneyOn == false) then
		ActivityMan:GetActivity():SetTeamFunds(0,0)
		ActivityMan:GetActivity():SetTeamFunds(0,1)
	end
--Money On
	if(MoneyOn == true) then
	
		--Find Current Funds
		p1Funds = ActivityMan:GetActivity():GetTeamFunds(0)
		p2Funds = ActivityMan:GetActivity():GetTeamFunds(1)

		--Add Funds to Defense
		if(basecontrol == 0) then
			if(defendmoneytimer:IsPastSimMS(MoneyTimeDefense)) then
				ActivityMan:GetActivity():SetTeamFunds(p1Funds + MoneyRateDefense, 0) 
				defendmoneytimer:Reset()
			end
		elseif(basecontrol == 1)then
			if(defendmoneytimer:IsPastSimMS(MoneyTimeDefense)) then
				ActivityMan:GetActivity():SetTeamFunds(p2Funds + MoneyRateDefense, 1) 
				defendmoneytimer:Reset()
			end
		end
		
		--Add Funds to Offense
		if(basecontrol == 1) then
			if(attackmoneytimer:IsPastSimMS(MoneyTimeOffense)) then
				ActivityMan:GetActivity():SetTeamFunds(p1Funds + MoneyRateOffense, 0) 
				attackmoneytimer:Reset()
			end
		elseif(basecontrol == 0)then
			if(attackmoneytimer:IsPastSimMS(MoneyTimeOffense)) then
				ActivityMan:GetActivity():SetTeamFunds(p2Funds + MoneyRateOffense, 1) 
				attackmoneytimer:Reset()
			end
		else
			if(attackmoneytimer:IsPastSimMS(MoneyTimeOffense)) then
				ActivityMan:GetActivity():SetTeamFunds(p1Funds + MoneyRateOffense, 0)
				ActivityMan:GetActivity():SetTeamFunds(p2Funds + MoneyRateOffense, 1) 
				attackmoneytimer:Reset()
			defendmoneytimer:Reset()
			end
		end	
	end
--Defense Spawn
	if(defendspawntimer:IsPastSimMS(RespawnTimeDefense)) then
		if(basecontrol == 0) then
			ship = MakeCraft(1,5);
			actor = MakeActor(Actor.AIMODE_GOTO);
			actor:ClearAIWaypoints();
			actor:AddAISceneWaypoint(Vector(defensemove:GetRandomPoint().X, defensemove:GetRandomPoint().Y));
			actor:AddAISceneWaypoint(Vector(defensemove:GetRandomPoint().X, defensemove:GetRandomPoint().Y));
			ship:AddInventoryItem(actor);
            ship.Pos.X = defendlz:GetRandomPoint().X;
			ship.Pos.Y = 0;
			ship.Team = 0;
			ship:SetControllerMode(Controller.CIM_AI, -1);
			MovableMan:AddActor(ship);
			defendspawntimer:Reset()
		elseif(basecontrol == 1) then
			ship = MakeCraft(0,4);
			actor = MakeActor(Actor.AIMODE_GOTO);
			actor:ClearAIWaypoints();
			actor:AddAISceneWaypoint(Vector(defensemove:GetRandomPoint().X, defensemove:GetRandomPoint().Y));
			ship:AddInventoryItem(actor);
            ship.Pos.X = defendlz:GetRandomPoint().X;
			ship.Pos.Y = 0;
			ship.Team = 1;
			ship:SetControllerMode(Controller.CIM_AI, -1);
			MovableMan:AddActor(ship);
			defendspawntimer:Reset()
		end
	end	
--Find Attack LZ
	ChooseAttackLZ = math.random();
    if(ChooseAttackLZ > .67 ) then
		AttackLZ = SceneMan.Scene:GetArea("attacklz0");
		offensearea = 0
	elseif(ChooseAttackLZ > .33) then
		AttackLZ = SceneMan.Scene:GetArea("attacklz1")
		offensearea = 1
	else
		AttackLZ = SceneMan.Scene:GetArea("attacklz2")
		offensearea = 2
	end
	
--Offense Spawn	
	if(attackspawntimer:IsPastSimMS(RespawnTimeOffense)) then
		if(basecontrol == 1) then
			ship = MakeCraft(0,2);
			if(AI == false) then
				actor1 = MakeActor(Actor.AIMODE_SENTRY);
				actor2 = MakeActor(Actor.AIMODE_SENTRY);
			else
				actor1 = MakeActor(Actor.AIMODE_GOTO);
				actor2 = MakeActor(Actor.AIMODE_GOTO);
			end
			actor:ClearAIWaypoints();
			if(AI == true) then
				-- Tell actor to go to a random zone
				WhereTo = math.random(0,3);
				math.floor(WhereTo);
				if (WhereTo == 0) then
					actor1:AddAISceneWaypoint(Zone0:GetRandomPoint())
					actor2:AddAISceneWaypoint(Zone0:GetRandomPoint())
				elseif (WhereTo == 1) then
					actor1:AddAISceneWaypoint(Zone1:GetRandomPoint())
					actor2:AddAISceneWaypoint(Zone1:GetRandomPoint())
				elseif (WhereTo == 2) then
					actor1:AddAISceneWaypoint(Zone2:GetRandomPoint())
					actor2:AddAISceneWaypoint(Zone2:GetRandomPoint())
				elseif (WhereTo == 3) then
					actor1:AddAISceneWaypoint(Zone3:GetRandomPoint())
					actor2:AddAISceneWaypoint(Zone3:GetRandomPoint())
				end
			end
			ship:AddInventoryItem(actor1);
			ship:AddInventoryItem(actor2);
            ship.Pos.X = AttackLZ:GetRandomPoint().X;
			ship.Pos.Y = 0;
			ship.Team = 0;
			ship:SetControllerMode(Controller.CIM_AI, -1);
			MovableMan:AddActor(ship);
			attackspawntimer:Reset()
		elseif(basecontrol == 0) then
			ship = MakeCraft(3,5);
			if(AI == false) then
				actor1 = MakeActor(Actor.AIMODE_SENTRY);
				actor2 = MakeActor(Actor.AIMODE_SENTRY);
			else
				actor1 = MakeActor(Actor.AIMODE_GOTO);
				actor2 = MakeActor(Actor.AIMODE_GOTO);
			end
			actor:ClearAIWaypoints();
			if(AI == true) then
								-- Tell actor to go to a random zone
				WhereTo = math.random(0,3);
				math.floor(WhereTo);
				if (WhereTo == 0) then
					actor1:AddAISceneWaypoint(Zone0:GetRandomPoint())
					actor2:AddAISceneWaypoint(Zone0:GetRandomPoint())
				elseif (WhereTo == 1) then
					actor1:AddAISceneWaypoint(Zone1:GetRandomPoint())
					actor2:AddAISceneWaypoint(Zone1:GetRandomPoint())
				elseif (WhereTo == 2) then
					actor1:AddAISceneWaypoint(Zone2:GetRandomPoint())
					actor2:AddAISceneWaypoint(Zone2:GetRandomPoint())
				elseif (WhereTo == 3) then
					actor1:AddAISceneWaypoint(Zone3:GetRandomPoint())
					actor2:AddAISceneWaypoint(Zone3:GetRandomPoint())
				end
			end
			ship:AddInventoryItem(actor1);
			ship:AddInventoryItem(actor2);
            ship.Pos.X = AttackLZ:GetRandomPoint().X;
			ship.Pos.Y = 0;
			ship.Team = 1;
			ship:SetControllerMode(Controller.CIM_AI, -1);
			MovableMan:AddActor(ship);
			attackspawntimer:Reset()
		else
			ship = MakeCraft(0,5);
			if(AI == false) then
				actor1 = MakeActor(Actor.AIMODE_SENTRY);
				actor2 = MakeActor(Actor.AIMODE_SENTRY);
			else
				actor1 = MakeActor(Actor.AIMODE_GOTO);
				actor2 = MakeActor(Actor.AIMODE_GOTO);
			end
			actor:ClearAIWaypoints();
			if(AI == true) then			
				-- Tell actor to go to a random zone	
				WhereTo = math.random(0,3);
				math.floor(WhereTo);
				if (WhereTo == 0) then
					actor1:AddAISceneWaypoint(Zone0:GetRandomPoint())
					actor2:AddAISceneWaypoint(Zone0:GetRandomPoint())
				elseif (WhereTo == 1) then
					actor1:AddAISceneWaypoint(Zone1:GetRandomPoint())
					actor2:AddAISceneWaypoint(Zone1:GetRandomPoint())
				elseif (WhereTo == 2) then
					actor1:AddAISceneWaypoint(Zone2:GetRandomPoint())
					actor2:AddAISceneWaypoint(Zone2:GetRandomPoint())
				elseif (WhereTo == 3) then
					actor1:AddAISceneWaypoint(Zone3:GetRandomPoint())
					actor2:AddAISceneWaypoint(Zone3:GetRandomPoint())
				end
			end	
			ship:AddInventoryItem(actor);
            ship.Pos.X = AttackLZ:GetRandomPoint().X;
			ship.Pos.Y = 0;
			ship.Team = 1;
			ship:SetControllerMode(Controller.CIM_AI, -1);
			MovableMan:AddActor(ship);
			ship = MakeCraft(0,5);
			if(AI == false) then
				actor1 = MakeActor(Actor.AIMODE_SENTRY);
				actor2 = MakeActor(Actor.AIMODE_SENTRY);
			else
				actor1 = MakeActor(Actor.AIMODE_GOTO);
				actor2 = MakeActor(Actor.AIMODE_GOTO);
			end			actor:ClearAIWaypoints();
			if(AI == true) then			
			-- Tell actor to go to a random zone
				WhereTo = math.random(0,3);
				math.floor(WhereTo);
				if (WhereTo == 0) then
					actor1:AddAISceneWaypoint(Zone0:GetRandomPoint())
					actor2:AddAISceneWaypoint(Zone0:GetRandomPoint())
				elseif (WhereTo == 1) then
					actor1:AddAISceneWaypoint(Zone1:GetRandomPoint())
					actor2:AddAISceneWaypoint(Zone1:GetRandomPoint())
				elseif (WhereTo == 2) then
					actor1:AddAISceneWaypoint(Zone2:GetRandomPoint())
					actor2:AddAISceneWaypoint(Zone2:GetRandomPoint())
				elseif (WhereTo == 3) then
					actor1:AddAISceneWaypoint(Zone3:GetRandomPoint())
					actor2:AddAISceneWaypoint(Zone3:GetRandomPoint())
				end
			end
			ship:AddInventoryItem(actor1);
			ship:AddInventoryItem(actor2);
            ship.Pos.X = AttackLZ:GetRandomPoint().X;
			ship.Pos.Y = 0;
			ship.Team = 0;
			ship:SetControllerMode(Controller.CIM_AI, -1);
			MovableMan:AddActor(ship);
			attackspawntimer:Reset()
		end
	end
	
--Game timer.
	loltimer = loltimer + 1;
--End game
	if(timelimit and timeleft <= 0) then
		FrameMan:ClearScreenText(0)
		FrameMan:ClearScreenText(1)
		FrameMan:SetScreenText("TIME'S UP! Player "..((((p2score-p1score)/math.abs(p2score-p1score))-1)/2+2).." wins with a score of: "..math.max(p1score,p2score).." seconds.",Activity.TEAM_1,0,-1,true)
		FrameMan:SetScreenText("TIME'S UP! Player "..((((p2score-p1score)/math.abs(p2score-p1score))-1)/2+2).." wins with a score of: "..math.max(p1score,p2score).." seconds.",Activity.TEAM_2,0,-1,true)
		ActivityMan:EndActivity()
	elseif(goaltimelimit and (p1score >= maxgoaltime or p2score >= maxgoaltime)) then
		FrameMan:ClearScreenText(0)
		FrameMan:ClearScreenText(1)
		FrameMan:SetScreenText("SCORE LIMIT REACHED! Player "..((((p2score-p1score)/math.abs(p2score-p1score))-1)/2+2).." wins with a score of: "..math.max(p1score,p2score).." seconds.",Activity.TEAM_1,0,-1,true)
		FrameMan:SetScreenText("SCORE LIMIT REACHED! Player "..((((p2score-p1score)/math.abs(p2score-p1score))-1)/2+2).." wins with a score of: "..math.max(p1score,p2score).." seconds.",Activity.TEAM_2,0,-1,true)
		ActivityMan:EndActivity()
	else
		--Update score/timelimit
		if(timelimit) then
			timeleft = timelimittimer:LeftTillSimMS(maxtime*1000)/10
			FrameMan:ClearScreenText(0)
			FrameMan:ClearScreenText(1)
			FrameMan:SetScreenText("P1: "..p1score.." seconds. Timeleft: "..(math.floor(timeleft/6000))..":"..(math.floor((timeleft%6000)/100)).." P2: "..p2score.." seconds.",Activity.TEAM_1,0,-50,false)
			FrameMan:SetScreenText("P1: "..p1score.." seconds. Timeleft: "..(math.floor(timeleft/6000))..":"..(math.floor((timeleft%6000)/100)).." P2: "..p2score.." seconds.",Activity.TEAM_2,0,-50,false)
		else
			FrameMan:ClearScreenText(0)
			FrameMan:ClearScreenText(1)
			FrameMan:SetScreenText("P1: "..p1score.." seconds. P2: "..p2score.." seconds.",Activity.TEAM_1,0,-50,false)
			FrameMan:SetScreenText("P1: "..p1score.." seconds. P2: "..p2score.." seconds.",Activity.TEAM_2,0,-50,false)
		end
	end
end

function AssaultMission:PauseActivity(pause)

end

function AssaultMission:EndActivity()
  if(p1score > p2score) then
  self.WinnerTeam = 0;
  end
  if(p1score < p2score) then
  self.WinnerTeam = 1;
  end
  if(p1score == p2score) then
  self.WinnerTeam = -1; --Ties suck.
  end
  --ActivityMan:EndActivity()
end  