function AssaultMission:StartActivity()
--[[
Assault
	a King of the Hill style gamemode.
	Capture over 3 of the 4 Zones to take control of the base.
	Capture Zones by having more bodies in the area than your opponent.
	Hold the base longer than your opponent within the time limit to win!
	
	The attacker recieves gold slightly faster than the defender.
	AI will move attacking troops directly to a random zone.
	Defending troops move to area directly underneath the drop zone.
	
	--Aspect
	thanks to mail2345 for randomized starting player
		and for fixing up spawns
	
	
	
	Game Options below
]]--

--[[
Reinforcement Number
	CoalitionStandard = 1
	RoninStandard = 2
	DummyStandard = 3
	CoalitionHeavy = 4
	RoninHeavy = 5
	SuperHeavy = 6
]]--
	ReinforcementType = 2 --Corresponds to number in table above
						--Incomplete, all but option 6 are finished.
--Time limit
	timelimit = true --Set to false if you wish to play with only the goal limit
	maxtime = 1200 --Amount of time until the match is over (in seconds)
--Goal limit
	goaltimelimit = true --Set to false if you wish to play with only the time limit
	maxgoaltime = 480 --Number of seconds needed to win
--Respawn Times 
	RespawnTimeDefense = 20000 --(in milliseconds, multiply seconds by 1000)
	RespawnTimeOffense = 15000
--Starting Funds
	DefenseStartFunds = 0 --(in oz. Gold)
	OffenseStartFunds = 1000
--Money Rate
	MoneyOn = false --Set to true if you wish to play with pensions
	MoneyTimeDefense = 750 --(in milliseconds)
	MoneyTimeOffense = 500
	MoneyRateDefense = 1.5 --(in oz. Gold)
	MoneyRateOffense = 2
--AI Moves to Zones
	AI = true --Set to false if you wish to play manually
--Handicap? (in seconds)
	p1score = 0
	p2score = 0
	
	
	
	
--Don't bother messing with the below values	
	loltimer = 0; --A fix for the bizzare don't touch actors within the first 15 iterations glitch.
	p1Zone0control = 0
	p1Zone1control = 0
	p1Zone2control = 0
	p1Zone3control = 0
	p2Zone0control = 0
	p2Zone1control = 0
	p2Zone2control = 0
	p2Zone3control = 0
	Zone0control = 0
	Zone1control = 0
	Zone2control = 0
	Zone3control = 0
	ZonesFull = false
	basecontrol = -1
	p1spawnactive = false
	p2spawnactive = false
	secondtimer = Timer()
	TimeCheck = 1000
	timelimittimer = Timer()
	timeleft = 999
	defendspawntimer = Timer()
	attackspawntimer = Timer()
	defendmoneytimer = Timer()
	attackmoneytimer = Timer()
	Zone0 = SceneMan.Scene:GetArea("Zone0")
	Zone1 = SceneMan.Scene:GetArea("Zone1")
	Zone2 = SceneMan.Scene:GetArea("Zone2")
	Zone3 = SceneMan.Scene:GetArea("Zone3")
	Start0 = SceneMan.Scene:GetArea("Start0")
	Start1 = SceneMan.Scene:GetArea("Start1")
	Start2 = SceneMan.Scene:GetArea("Start2")
	Start3 = SceneMan.Scene:GetArea("Start3")
	attacklz0 = SceneMan.Scene:GetArea("attacklz0")
	attacklz1 = SceneMan.Scene:GetArea("attacklz1")
	attacklz2 = SceneMan.Scene:GetArea("attacklz2")
	defendlz = SceneMan.Scene:GetArea("defendlz")
	defensemove = SceneMan.Scene:GetArea("defensemove")
	
	ActivityMan:GetActivity():SetTeamFunds(DefenseStartFunds,0)
	ActivityMan:GetActivity():SetTeamFunds(OffenseStartFunds,1)	
	
--Randomize Starting Position
	which = math.random(1,2);
    if which == 2 then
		spawnteam = 1;
		ActivityMan:GetActivity():SetTeamFunds(DefenseStartFunds,1)
		ActivityMan:GetActivity():SetTeamFunds(OffenseStartFunds,0)
	end
	
	if which == 1 then
		spawnteam = 0;
		ActivityMan:GetActivity():SetTeamFunds(DefenseStartFunds,0)
		ActivityMan:GetActivity():SetTeamFunds(OffenseStartFunds,1)
	end
--Create Starting Soldiers	
	actor = MakeActor(Actor.AIMODE_SENTRY);
	actor:ClearAIWaypoints();
	actor.Team = spawnteam;
	actor.Pos = Vector(Start0:GetRandomPoint().X, Start0:GetRandomPoint().Y);
	MovableMan:AddActor(actor);
	
	actor = MakeActor(Actor.AIMODE_SENTRY);
	actor:ClearAIWaypoints();
	actor.Team = spawnteam;
	actor.Pos = Vector(Start1:GetRandomPoint().X, Start1:GetRandomPoint().Y);
	MovableMan:AddActor(actor);
	
	actor = MakeActor(Actor.AIMODE_SENTRY);
	actor:ClearAIWaypoints();
	actor.Team = spawnteam;
	actor.Pos = Vector(Start2:GetRandomPoint().X, Start2:GetRandomPoint().Y);
	MovableMan:AddActor(actor);
	
	actor = MakeActor(Actor.AIMODE_SENTRY);
	actor:ClearAIWaypoints();
	actor.Team = spawnteam;
	actor.Pos = Vector(Start3:GetRandomPoint().X, Start3:GetRandomPoint().Y);
	MovableMan:AddActor(actor);

	--Need brainz
	for player = 0, self.PlayerCount - 1 do
        -- Check if we already have a brain assigned
        if not self:GetPlayerBrain(player) then
            local foundBrain = MovableMan:GetUnassignedBrain(self:GetTeamOfPlayer(player));
            -- If we can't find an unassigned brain in the scene to give each player, then force to go into editing mode to place one
            if not foundBrain then
                self.ActivityState = Activity.EDITING;
                print("Can't find player brain for tutorial game mode, forcing player to place one manually in edit mode!");
            else
                -- Set the found brain to be the selected actor at start
                self:SetPlayerBrain(foundBrain, player);
                self:SwitchToActor(foundBrain, player, self:GetTeamOfPlayer(player));
                self:SetLandingZone(self:GetPlayerBrain(player).Pos, player);
                -- Set the observation target to the brain, so that if/when it dies, the view flies to it in observation mode
                self:SetObservationTarget(self:GetPlayerBrain(player).Pos, player)
            end
        end
    end
	

end

--Spawning Actors
function MakeActor(whichMode)
	if(ReinforcementType == 1) then
		--local actor;
		--local which = math.random();
		if which > 0.25 then
			actor = CreateAHuman("Soldier Light","Coalition.rte");
		else
			actor = CreateAHuman("Soldier Heavy","Coalition.rte");
		end

		--local gun;
		
		which = math.random();
		if which > 0.92 then
			actor:AddInventoryItem(CreateHDFirearm("Shotgun","Coalition.rte"));
		elseif which > 0.89 then
			actor:AddInventoryItem(CreateHDFirearm("Auto Shotgun","Coalition.rte"));
		elseif which > 0.86 then
			actor:AddInventoryItem(CreateHDFirearm("Heavy Auto Shotgun","Coalition.rte"));
		elseif which > 0.83 then
			actor:AddInventoryItem(CreateHDFirearm("Auto Cannon","Coalition.rte"));
		elseif which > 0.52 then
			actor:AddInventoryItem(CreateHDFirearm("Assault Rifle","Coalition.rte"));
		elseif which > 0.50 then
			actor:AddInventoryItem(CreateHDFirearm("Gatling Gun","Coalition.rte"));
		elseif which > 0.48 then
			actor:AddInventoryItem(CreateHDFirearm("Compact Rifle","Coalition.rte"));
		elseif which > 0.45 then
			actor:AddInventoryItem(CreateHDFirearm("Rocket Launcher","Coalition.rte"));
		elseif which > 0.25 then
			actor:AddInventoryItem(CreateHDFirearm("Sniper Rifle","Coalition.rte"));
		elseif which > 0.22 then
			actor:AddInventoryItem(CreateHDFirearm("Heavy Sniper Rifle","Coalition.rte"));
		elseif which > 0.20 then
			actor:AddInventoryItem(CreateHDFirearm("Revolver Cannon","Coalition.rte"));
		elseif which > 0.05 then
			actor:AddInventoryItem(CreateHDFirearm("Compact Cannon","Coalition.rte"));
		else
			actor:AddInventoryItem(CreateHDFirearm("Flak Cannon","Coalition.rte"));
		end
		
		--local tool;
		which = math.random();
		if which > 0.85 then
			actor:AddInventoryItem(CreateHDFirearm("Pulse Digger","Coalition.rte"));
		elseif which > 0.75 then
			actor:AddInventoryItem(CreateHDFirearm("Grenade Launcher","Coalition.rte"));
		elseif which > 0.35 then
			actor:AddInventoryItem(CreateTDExplosive("Frag Grenade","Coalition.rte"));
		elseif which > 0.30 then
			actor:AddInventoryItem(CreateHDFirearm("Concrete Gun","Coalition.rte"));
		elseif which > 0.29 then
			actor:AddInventoryItem(CreateTDExplosive("Stone","Ronin.rte"));
		end
		
		--local sidearm;
		which = math.random();
		if which > 0.70 then
			actor:AddInventoryItem(CreateHDFirearm("Pistol","Coalition.rte"));
		elseif which > 0.50 then
			actor:AddInventoryItem(CreateHDFirearm("Auto Pistol","Coalition.rte"));
		elseif which > 0.40 then
			actor:AddInventoryItem(CreateHDFirearm("Auto Shot Pistol","Coalition.rte"));
		end

		actor:SetControllerMode(Controller.CIM_AI, -1);
		actor.AIMode = whichMode;
		return actor;
	end
	if(ReinforcementType == 2) then
	
		--local actor;
		--local which = math.random();
		if which > 0.8 then
			actor = CreateAHuman("Ronin Soldier 1","Ronin.rte");
		elseif which > 0.64 then
			actor = CreateAHuman("Ronin Soldier 2","Ronin.rte");
		elseif which > 0.48 then
			actor = CreateAHuman("Ronin Soldier 3","Ronin.rte");
		elseif which > 0.32 then
			actor = CreateAHuman("Ronin Soldier 4","Ronin.rte");
		elseif which > 0.16 then
			actor = CreateAHuman("Ronin Soldier 5","Ronin.rte");
		else
			actor = CreateAHuman("Ronin Soldier 6","Ronin.rte");
		end

		--local gun;
		
		which = math.random();
		if which > 0.80 then
			actor:AddInventoryItem(CreateHDFirearm("Spas12","Ronin.rte"));
		elseif which > 0.60 then
			actor:AddInventoryItem(CreateHDFirearm("M16","Ronin.rte"));
		elseif which > 0.40 then
			actor:AddInventoryItem(CreateHDFirearm("YAK47","Ronin.rte"));
		elseif which > 0.25 then
			actor:AddInventoryItem(CreateHDFirearm("Rifle Long","Ronin.rte"));
		elseif which > 0.15 then
			actor:AddInventoryItem(CreateHDFirearm("M1600","Ronin.rte"));
		elseif which > 0.5 then
			actor:AddInventoryItem(CreateHDFirearm("Sniper Rifle","Ronin.rte"));
		else
			actor:AddInventoryItem(CreateHDFirearm("Spas1200","Ronin.rte"));
		end
		
		--local tool;
		which = math.random();
		if which > 0.85 then
			actor:AddInventoryItem(CreateHDFirearm("Shovel","Ronin.rte"));
		elseif which > 0.75 then
			actor:AddInventoryItem(CreateTDExplosive("Stick Grenade","Ronin.rte"));
		elseif which > 0.35 then
			actor:AddInventoryItem(CreateTDExplosive("Pineapple Grenade","Ronin.rte"));
		elseif which > 0.30 then
			actor:AddInventoryItem(CreateHDFirearm("Concrete Gun","Base.rte"));
		elseif which > 0.25 then
			actor:AddInventoryItem(CreateTDExplosive("Stone","Ronin.rte"));
		end
		
		--local sidearm;
		which = math.random();
		if which > 0.90 then
			actor:AddInventoryItem(CreateHDFirearm("Lady Pistol","Ronin.rte"));
		elseif which > 0.75 then
			actor:AddInventoryItem(CreateHDFirearm("Glock","Ronin.rte"));
		elseif which > 0.60 then
			actor:AddInventoryItem(CreateHDFirearm("HAK 20","Ronin.rte"));
		elseif which > 0.50 then
			actor:AddInventoryItem(CreateHDFirearm("Luger","Ronin.rte"));
		elseif which > 0.40 then
			actor:AddInventoryItem(CreateHDFirearm("Desert Eagle","Ronin.rte"));
		elseif which > 0.30 then
			actor:AddInventoryItem(CreateHDFirearm("Peacemaker","Ronin.rte"));
		elseif which > 0.20 then
			actor:AddInventoryItem(CreateHDFirearm("Shotgun Short","Ronin.rte"));
		elseif which > 0.15 then
			actor:AddInventoryItem(CreateHDFirearm("Shotgun","Ronin.rte"));
		else
			actor:AddInventoryItem(CreateHDFirearm("Uzi","Ronin.rte"));
		
		end

		actor:SetControllerMode(Controller.CIM_AI, -1);
		actor.AIMode = whichMode;
		return actor;
	end
	if(ReinforcementType == 3) then
		--local actor;
		--local which = math.random();
		actor = CreateAHuman("Dummy","Dummy.rte");
		
		--local gun;
		
		which = math.random();
		if which > 0.65 then
			actor:AddInventoryItem(CreateHDFirearm("Dummy Nailgun","Dummy.rte"));
		elseif which > 0.25 then
			actor:AddInventoryItem(CreateHDFirearm("Dummy Blaster","Dummy.rte"));
		else
			actor:AddInventoryItem(CreateHDFirearm("Dummy Sniper","Dummy.rte"));
		end
		
		--local tool;
		which = math.random();
		if which > 0.85 then
			actor:AddInventoryItem(CreateHDFirearm("Dummy Digger","Dummy.rte"));
		elseif which > 0.70 then
			actor:AddInventoryItem(CreateHDFirearm("Dummy Grenade Launcher","Dummy.rte"));
		elseif which > 0.55 then
			actor:AddInventoryItem(CreateHDFirearm("Concrete Gun","Base.rte"));
		elseif which > 0.54 then
			actor:AddInventoryItem(CreateTDExplosive("Stone","Ronin.rte"));
		end
		
		--local sidearm;
		which = math.random();
		if which > 0.50 then
			actor:AddInventoryItem(CreateHDFirearm("Dummy Pistol","Dummy.rte"));
		elseif which > 0.40 then
			actor:AddInventoryItem(CreateHDFirearm("Dummy Nailgun","Dummy.rte"));	
		end
	end
	if(ReinforcementType == 4) then
		--local actor;
		--local which = math.random();
		if which > 0.85 then
			actor = CreateAHuman("Soldier Light","Coalition.rte");
		else
			actor = CreateAHuman("Soldier Heavy","Coalition.rte");
		end

		--local gun;
		
		which = math.random();
		if which > 0.85 then
			actor:AddInventoryItem(CreateHDFirearm("Auto Cannon","Coalition.rte"));
		elseif which > 0.75 then
			actor:AddInventoryItem(CreateHDFirearm("Gatling Gun","Coalition.rte"));
		elseif which > 0.60 then
			actor:AddInventoryItem(CreateHDFirearm("Rocket Launcher","Coalition.rte"));
		elseif which > 0.45 then
			actor:AddInventoryItem(CreateHDFirearm("Heavy Sniper Rifle","Coalition.rte"));
		elseif which > 0.30 then
			actor:AddInventoryItem(CreateHDFirearm("Revolver Cannon","Coalition.rte"));
		elseif which > 0.20 then
			actor:AddInventoryItem(CreateHDFirearm("Compact Cannon","Coalition.rte"));
		else
			actor:AddInventoryItem(CreateHDFirearm("Flak Cannon","Coalition.rte"));
		end
		
		--local tool;
		which = math.random();
		if which > 0.85 then
			actor:AddInventoryItem(CreateHDFirearm("Pulse Digger","Coalition.rte"));
		elseif which > 0.75 then
			actor:AddInventoryItem(CreateHDFirearm("Grenade Launcher","Coalition.rte"));
		elseif which > 0.35 then
			actor:AddInventoryItem(CreateTDExplosive("Frag Grenade","Coalition.rte"));
		elseif which > 0.30 then
			actor:AddInventoryItem(CreateHDFirearm("Concrete Gun","Coalition.rte"));
		elseif which > 0.29 then
			actor:AddInventoryItem(CreateTDExplosive("Stone","Ronin.rte"));
		end
		
		--local sidearm;
		which = math.random();
		if which > 0.90 then
			actor:AddInventoryItem(CreateHDFirearm("Shotgun","Coalition.rte"));
		elseif which > 0.80 then
			actor:AddInventoryItem(CreateHDFirearm("Auto Pistol","Coalition.rte"));
		elseif which > 0.60 then
			actor:AddInventoryItem(CreateHDFirearm("Auto Shot Pistol","Coalition.rte"));
		end

		actor:SetControllerMode(Controller.CIM_AI, -1);
		actor.AIMode = whichMode;
		return actor;
	end
	if(ReinforcementType == 5) then
	
		--local actor;
		--local which = math.random();
		if which > 0.8 then
			actor = CreateAHuman("Ronin Soldier 1","Ronin.rte");
		elseif which > 0.64 then
			actor = CreateAHuman("Ronin Soldier 2","Ronin.rte");
		elseif which > 0.48 then
			actor = CreateAHuman("Ronin Soldier 3","Ronin.rte");
		elseif which > 0.32 then
			actor = CreateAHuman("Ronin Soldier 4","Ronin.rte");
		elseif which > 0.16 then
			actor = CreateAHuman("Ronin Soldier 5","Ronin.rte");
		else
			actor = CreateAHuman("Ronin Soldier 6","Ronin.rte");
		end

		--local gun;
		
		which = math.random();
		if which > 0.80 then
			actor:AddInventoryItem(CreateHDFirearm("Spas1200","Ronin.rte"));
		elseif which > 0.70 then
			actor:AddInventoryItem(CreateHDFirearm("M16","Ronin.rte"));
		elseif which > 0.50 then
			actor:AddInventoryItem(CreateHDFirearm("YAK4700","Ronin.rte"));
		elseif which > 0.40 then
			actor:AddInventoryItem(CreateHDFirearm("Rifle Long","Ronin.rte"));
		elseif which > 0.30 then
			actor:AddInventoryItem(CreateHDFirearm("M1600","Ronin.rte"));
		elseif which > 0.10 then
			actor:AddInventoryItem(CreateHDFirearm("Bazooka","Ronin.rte"));
		elseif which > 0.5 then
			actor:AddInventoryItem(CreateHDFirearm("YAK47","Ronin.rte"));
		else
			actor:AddInventoryItem(CreateHDFirearm("Spas12","Ronin.rte"));
		end
		
		--local tool;
		which = math.random();
		if which > 0.85 then
			actor:AddInventoryItem(CreateHDFirearm("Shovel","Ronin.rte"));
		elseif which > 0.75 then
			actor:AddInventoryItem(CreateHDFirearm("Stick Grenade","Ronin.rte"));
		elseif which > 0.35 then
			actor:AddInventoryItem(CreateTDExplosive("Pineapple Grenade","Ronin.rte"));
		elseif which > 0.30 then
			actor:AddInventoryItem(CreateHDFirearm("Concrete Gun","Base.rte"));
		elseif which > 0.25 then
			actor:AddInventoryItem(CreateTDExplosive("Stone","Ronin.rte"));
		end
		
		--local sidearm;
		which = math.random();
		if which > 0.95 then
			actor:AddInventoryItem(CreateHDFirearm("Lady Pistol","Ronin.rte"));
		elseif which > 0.85 then
			actor:AddInventoryItem(CreateHDFirearm("Glock","Ronin.rte"));
		elseif which > 0.75 then
			actor:AddInventoryItem(CreateHDFirearm("HAK 20","Ronin.rte"));
		elseif which > 0.65 then
			actor:AddInventoryItem(CreateHDFirearm("Luger","Ronin.rte"));
		elseif which > 0.55 then
			actor:AddInventoryItem(CreateHDFirearm("Desert Eagle","Ronin.rte"));
		elseif which > 0.40 then
			actor:AddInventoryItem(CreateHDFirearm("Peacemaker","Ronin.rte"));
		elseif which > 0.30 then
			actor:AddInventoryItem(CreateHDFirearm("Shotgun Short","Ronin.rte"));
		elseif which > 0.20 then
			actor:AddInventoryItem(CreateHDFirearm("Shotgun","Ronin.rte"));
		else
			actor:AddInventoryItem(CreateHDFirearm("Uzi","Ronin.rte"));
		
		end

		actor:SetControllerMode(Controller.CIM_AI, -1);
		actor.AIMode = whichMode;
		return actor;
	end
end

function AssaultMission:UpdateActivity()
	--Check scoring areas and update player count
	--Single loop through actors means each actor is only accessed once. There shouldn't be any other "for actor in MovableMan" etc.
	team1count = 0
	team2count = 0
	for actor in MovableMan.Actors do
		if(actor.Team == Activity.TEAM_1) then
			if(SceneMan.Scene:WithinArea("Zone0",actor.Pos)) then
				p1Zone0control = p1Zone0control + 1
			elseif(SceneMan.Scene:WithinArea("Zone1",actor.Pos)) then
				p1Zone1control = p1Zone1control + 1
			elseif(SceneMan.Scene:WithinArea("Zone2",actor.Pos)) then
				p1Zone2control = p1Zone2control + 1
			elseif(SceneMan.Scene:WithinArea("Zone3",actor.Pos)) then
				p1Zone3control = p1Zone3control + 1		
			end
		elseif(actor.Team == Activity.TEAM_2) then
			if(SceneMan.Scene:WithinArea("Zone0",actor.Pos)) then
				p2Zone0control = p2Zone0control + 1
			elseif(SceneMan.Scene:WithinArea("Zone1",actor.Pos)) then
				p2Zone1control = p2Zone1control + 1
			elseif(SceneMan.Scene:WithinArea("Zone2",actor.Pos)) then
				p2Zone2control = p2Zone2control + 1
			elseif(SceneMan.Scene:WithinArea("Zone3",actor.Pos)) then
				p2Zone3control = p2Zone3control + 1
			end
		end
	end

--Set Zone0 Control
	if(p1Zone0control > p2Zone0control) then
			Zone0control = -1
			p1Zone0control = 0
			p2Zone0control = 0
	elseif(p2Zone0control > p1Zone0control) then
			Zone0control = 1
			p1Zone0control = 0
			p2Zone0control = 0
	else
			Zone0control = 0
			p1Zone0control = 0
			p2Zone0control = 0
	end

--Set Zone1 Control
	if(p1Zone1control > p2Zone1control) then
			Zone1control = -1
			p1Zone1control = 0
			p2Zone1control = 0
	elseif(p2Zone1control > p1Zone1control) then
			Zone1control = 1
			p1Zone1control = 0
			p2Zone1control = 0
	else
			Zone1control = 0
			p1Zone10control = 0
			p2Zone1control = 0
	end
	
--Set Zone2 Control
	if(p1Zone2control > p2Zone2control) then
			Zone2control = -1
			p1Zone2control = 0
			p2Zone2control = 0
	elseif(p2Zone2control > p1Zone2control) then
			Zone2control = 1
			p1Zone2control = 0
			p2Zone2control = 0
	else
			Zone2control = 0
			p1Zone2control = 0
			p2Zone2control = 0
	end
	
--Set Zone3 Control
	if(p1Zone3control > p2Zone3control) then
			Zone3control = -1
			p1Zone3control = 0
			p2Zone3control = 0
	elseif(p2Zone3control > p1Zone3control) then
			Zone3control = 1
			p1Zone3control = 0
			p2Zone3control = 0
	else
			Zone3control = 0
			p1Zone3control = 0
			p2Zone3control = 0
	end

--Total Values for Zone Control	
	ZoneControlTotal = Zone0control + Zone1control + Zone2control + Zone3control

--Find Base Control	
	if(Zone0control == 0) then
		ZonesFull = false
	elseif(Zone1control == 0) then
		ZonesFull = false
	elseif(Zone2control == 0) then
		ZonesFull = false
	elseif(Zone3control == 0) then
		ZonesFull = false
	else
		ZonesFull = true
	end
	
--Set Base Control
	if(ZoneControlTotal < -1 and ZonesFull == true) then
		basecontrol = 0
	elseif(ZoneControlTotal > 1 and ZonesFull == true) then
		basecontrol = 1
	elseif(ZoneControlTotal < -2 and ZonesFull == false) then
		basecontrol = 0
	elseif(ZoneControlTotal > 2 and ZonesFull == false) then
		basecontrol = 1
	else
		basecontrol = -1
	end
	
--Door Team Switch
	if(basecontrol == 0) then
		for door in MovableMan.Actors do  
			if door.ClassName == "ADoor" then
				door.Team = 0
			end
		end
	elseif(basecontrol == 1) then
		for door in MovableMan.Actors do  
			if door.ClassName == "ADoor" then
				door.Team = 1
			end
		end
	else
		for door in MovableMan.Actors do  
			if door.ClassName == "ADoor" then
				door.Team = -1
			end
		end
	end	
--Score Timer
	if(basecontrol == 0) then
		if(secondtimer:IsPastSimMS(TimeCheck)) then
			p1score = p1score + 1	
			secondtimer:Reset()
		end
	elseif(basecontrol == 1)then
		if(secondtimer:IsPastSimMS(TimeCheck)) then
			p2score = p2score + 1	
			secondtimer:Reset()
		end
	end
--Money	Off
	if(MoneyOn == false) then
		ActivityMan:GetActivity():SetTeamFunds(0,0)
		ActivityMan:GetActivity():SetTeamFunds(0,1)
	end
--Money On
	if(MoneyOn == true) then
	
		--Find Current Funds
		p1Funds = ActivityMan:GetActivity():GetTeamFunds(0)
		p2Funds = ActivityMan:GetActivity():GetTeamFunds(1)

		--Add Funds to Defense
		if(basecontrol == 0) then
			if(defendmoneytimer:IsPastSimMS(MoneyTimeDefense)) then
				ActivityMan:GetActivity():SetTeamFunds(p1Funds + MoneyRateDefense, 0) 
				defendmoneytimer:Reset()
			end
		elseif(basecontrol == 1)then
			if(defendmoneytimer:IsPastSimMS(MoneyTimeDefense)) then
				ActivityMan:GetActivity():SetTeamFunds(p2Funds + MoneyRateDefense, 1) 
				defendmoneytimer:Reset()
			end
		end
		
		--Add Funds to Offense
		if(basecontrol == 1) then
			if(attackmoneytimer:IsPastSimMS(MoneyTimeOffense)) then
				ActivityMan:GetActivity():SetTeamFunds(p1Funds + MoneyRateOffense, 0) 
				attackmoneytimer:Reset()
			end
		elseif(basecontrol == 0)then
			if(attackmoneytimer:IsPastSimMS(MoneyTimeOffense)) then
				ActivityMan:GetActivity():SetTeamFunds(p2Funds + MoneyRateOffense, 1) 
				attackmoneytimer:Reset()
			end
		else
			if(attackmoneytimer:IsPastSimMS(MoneyTimeOffense)) then
				ActivityMan:GetActivity():SetTeamFunds(p1Funds + MoneyRateOffense, 0)
				ActivityMan:GetActivity():SetTeamFunds(p2Funds + MoneyRateOffense, 1) 
				attackmoneytimer:Reset()
			defendmoneytimer:Reset()
			end
		end	
	end
--Defense Spawn
	if(defendspawntimer:IsPastSimMS(RespawnTimeDefense)) then
		if(basecontrol == 0) then
			ship = CreateACDropShip("Drop Ship MK1");
			actor = MakeActor(Actor.AIMODE_GOTO);
			actor:ClearAIWaypoints();
			actor:AddAISceneWaypoint(Vector(defensemove:GetRandomPoint().X, defensemove:GetRandomPoint().Y));
			ship:AddInventoryItem(actor);
            ship.Pos.X = defendlz:GetRandomPoint().X;
			ship.Pos.Y = 0;
			ship.Team = 0;
			ship:SetControllerMode(Controller.CIM_AI, -1);
			MovableMan:AddActor(ship);
			defendspawntimer:Reset()
		elseif(basecontrol == 1) then
			ship = CreateACDropShip("Drop Ship MK1");
			actor = MakeActor(Actor.AIMODE_GOTO);
			actor:ClearAIWaypoints();
			actor:AddAISceneWaypoint(Vector(defensemove:GetRandomPoint().X, defensemove:GetRandomPoint().Y));
			ship:AddInventoryItem(actor);
            ship.Pos.X = defendlz:GetRandomPoint().X;
			ship.Pos.Y = 0;
			ship.Team = 1;
			ship:SetControllerMode(Controller.CIM_AI, -1);
			MovableMan:AddActor(ship);
			defendspawntimer:Reset()
		end
	end	
--Find Attack LZ
	ChooseAttackLZ = math.random();
    if(ChooseAttackLZ > .67 ) then
		AttackLZ = SceneMan.Scene:GetArea("attacklz0");
	elseif(ChooseAttackLZ > .33) then
		AttackLZ = SceneMan.Scene:GetArea("attacklz1")
	else
		AttackLZ = SceneMan.Scene:GetArea("attacklz2")
	end
	
--Offense Spawn	
	if(attackspawntimer:IsPastSimMS(RespawnTimeOffense)) then
		if(basecontrol == 1) then
			ship = CreateACDropShip("Drop Ship MK1");
			if(AI == false) then
				actor = MakeActor(Actor.AIMODE_SENTRY);
			else
				actor = MakeActor(Actor.AIMODE_GOTO);
			end
			actor:ClearAIWaypoints();
			if(AI == true) then
				-- Tell actor to go to a random zone
				WhereTo = math.random(0,3);
				math.floor(WhereTo);
				if (WhereTo == 0) then
					actor:AddAISceneWaypoint(Zone0:GetRandomPoint())
				elseif (WhereTo == 1) then
					actor:AddAISceneWaypoint(Zone1:GetRandomPoint())
				elseif (WhereTo == 2) then
					actor:AddAISceneWaypoint(Zone2:GetRandomPoint())
				elseif (WhereTo == 3) then
					actor:AddAISceneWaypoint(Zone3:GetRandomPoint())
				end
			end
			ship:AddInventoryItem(actor);
            ship.Pos.X = AttackLZ:GetRandomPoint().X;
			ship.Pos.Y = 0;
			ship.Team = 0;
			ship:SetControllerMode(Controller.CIM_AI, -1);
			MovableMan:AddActor(ship);
			attackspawntimer:Reset()
		elseif(basecontrol == 0) then
			ship = CreateACDropShip("Drop Ship MK1");
			if(AI == false) then
				actor = MakeActor(Actor.AIMODE_SENTRY);
			else
				actor = MakeActor(Actor.AIMODE_GOTO);
			end
			actor:ClearAIWaypoints();
			if(AI == true) then
								-- Tell actor to go to a random zone
				WhereTo = math.random(0,3);
				math.floor(WhereTo);
				if (WhereTo == 0) then
					actor:AddAISceneWaypoint(Zone0:GetRandomPoint())
				elseif (WhereTo == 1) then
					actor:AddAISceneWaypoint(Zone1:GetRandomPoint())
				elseif (WhereTo == 2) then
					actor:AddAISceneWaypoint(Zone2:GetRandomPoint())
				elseif (WhereTo == 3) then
					actor:AddAISceneWaypoint(Zone3:GetRandomPoint())
				end
			end
			ship:AddInventoryItem(actor);
            ship.Pos.X = AttackLZ:GetRandomPoint().X;
			ship.Pos.Y = 0;
			ship.Team = 1;
			ship:SetControllerMode(Controller.CIM_AI, -1);
			MovableMan:AddActor(ship);
			attackspawntimer:Reset()
		else
			ship = CreateACDropShip("Drop Ship MK1");
			if(AI == false) then
				actor = MakeActor(Actor.AIMODE_SENTRY);
			else
				actor = MakeActor(Actor.AIMODE_GOTO);
			end
			actor:ClearAIWaypoints();
			if(AI == true) then			
				-- Tell actor to go to a random zone	
				WhereTo = math.random(0,3);
				math.floor(WhereTo);
				if (WhereTo == 0) then
					actor:AddAISceneWaypoint(Zone0:GetRandomPoint())
				elseif (WhereTo == 1) then
					actor:AddAISceneWaypoint(Zone1:GetRandomPoint())
				elseif (WhereTo == 2) then
					actor:AddAISceneWaypoint(Zone2:GetRandomPoint())
				elseif (WhereTo == 3) then
					actor:AddAISceneWaypoint(Zone3:GetRandomPoint())
				end
			end	
			ship:AddInventoryItem(actor);
            ship.Pos.X = AttackLZ:GetRandomPoint().X;
			ship.Pos.Y = 0;
			ship.Team = 1;
			ship:SetControllerMode(Controller.CIM_AI, -1);
			MovableMan:AddActor(ship);
			ship = CreateACDropShip("Drop Ship MK1");
			if(AI == false) then
				actor = MakeActor(Actor.AIMODE_SENTRY);
			else
				actor = MakeActor(Actor.AIMODE_GOTO);
			end			actor:ClearAIWaypoints();
			if(AI == true) then			
			-- Tell actor to go to a random zone
				WhereTo = math.random(0,3);
				math.floor(WhereTo);
				if (WhereTo == 0) then
					actor:AddAISceneWaypoint(Zone0:GetRandomPoint())
				elseif (WhereTo == 1) then
					actor:AddAISceneWaypoint(Zone1:GetRandomPoint())
				elseif (WhereTo == 2) then
					actor:AddAISceneWaypoint(Zone2:GetRandomPoint())
				elseif (WhereTo == 3) then
					actor:AddAISceneWaypoint(Zone3:GetRandomPoint())
				end
			end
			ship:AddInventoryItem(actor);
            ship.Pos.X = AttackLZ:GetRandomPoint().X;
			ship.Pos.Y = 0;
			ship.Team = 0;
			ship:SetControllerMode(Controller.CIM_AI, -1);
			MovableMan:AddActor(ship);
			attackspawntimer:Reset()
		end
	end
	
--Game timer.
	loltimer = loltimer + 1;
--End game
	if(timelimit and timeleft <= 0) then
		FrameMan:ClearScreenText(0)
		FrameMan:ClearScreenText(1)
		FrameMan:SetScreenText("TIME'S UP! Player "..((((p2score-p1score)/math.abs(p2score-p1score))-1)/2+2).." wins with a score of: "..math.max(p1score,p2score).." seconds.",Activity.TEAM_1,0,-1,true)
		FrameMan:SetScreenText("TIME'S UP! Player "..((((p2score-p1score)/math.abs(p2score-p1score))-1)/2+2).." wins with a score of: "..math.max(p1score,p2score).." seconds.",Activity.TEAM_2,0,-1,true)
		ActivityMan:EndActivity()
	elseif(goaltimelimit and (p1score >= maxgoaltime or p2score >= maxgoaltime)) then
		FrameMan:ClearScreenText(0)
		FrameMan:ClearScreenText(1)
		FrameMan:SetScreenText("SCORE LIMIT REACHED! Player "..((((p2score-p1score)/math.abs(p2score-p1score))-1)/2+2).." wins with a score of: "..math.max(p1score,p2score).." seconds.",Activity.TEAM_1,0,-1,true)
		FrameMan:SetScreenText("SCORE LIMIT REACHED! Player "..((((p2score-p1score)/math.abs(p2score-p1score))-1)/2+2).." wins with a score of: "..math.max(p1score,p2score).." seconds.",Activity.TEAM_2,0,-1,true)
		ActivityMan:EndActivity()
	else
		--Update score/timelimit
		if(timelimit) then
			timeleft = timelimittimer:LeftTillSimMS(maxtime*1000)/10
			FrameMan:ClearScreenText(0)
			FrameMan:ClearScreenText(1)
			FrameMan:SetScreenText("P1: "..p1score.." seconds. Timeleft: "..(math.floor(timeleft/6000))..":"..(math.floor((timeleft%6000)/100)).." P2: "..p2score.." seconds.",Activity.TEAM_1,0,-50,false)
			FrameMan:SetScreenText("P1: "..p1score.." seconds. Timeleft: "..(math.floor(timeleft/6000))..":"..(math.floor((timeleft%6000)/100)).." P2: "..p2score.." seconds.",Activity.TEAM_2,0,-50,false)
		else
			FrameMan:ClearScreenText(0)
			FrameMan:ClearScreenText(1)
			FrameMan:SetScreenText("P1: "..p1score.." seconds. P2: "..p2score.." seconds.",Activity.TEAM_1,0,-50,false)
			FrameMan:SetScreenText("P1: "..p1score.." seconds. P2: "..p2score.." seconds.",Activity.TEAM_2,0,-50,false)
		end
	end
end

function AssaultMission:PauseActivity(pause)

end

function AssaultMission:EndActivity()
  if(p1score > p2score) then
  self.WinnerTeam = 0;
  end
  if(p1score < p2score) then
  self.WinnerTeam = 1;
  end
  if(p1score == p2score) then
  self.WinnerTeam = -1; --Ties suck.
  end
end  